// CRC64   ,  
// Proteus
// icq: 133575351  email:lawnmower-man@mail.ru 

#include<stdio.h>
#include<string.h>

typedef unsigned __int64 qword;
typedef unsigned char byte;

//  
#define POLYNOM64_ISO1	0x000000000000001B	//(ISO 3309)
#define POLYNOM64_ISO2	0xD800000000000000
#define POLYNOM64_ISO3	0xB000000000000001
#define POLYNOM64_ECMA1	0x42F0E1EBA9EA3693	//(ECMA-182)
#define POLYNOM64_ECMA2	0xC96C5795D7870F42
#define POLYNOM64_ECMA3	0x92D8AF2BAF0E1E85


//!     
class CRC64 {
	qword crc64_table[256];
public:
	CRC64(qword polynom=POLYNOM64_ECMA2);
	qword Calc(byte*,int count);
};


CRC64::CRC64(qword polynom)
{
	int n,k; qword c;
	for(n=0;n<256;n++) {
		c=n;
		for(k=0;k<8;k++) c=c>>1^(-(int)(c&1)&polynom);
		crc64_table[n]=c;
	}
}

qword CRC64::Calc(byte* data,int count)
{
	qword value=(qword)-1; 
	while(count--) value=(value>>8)^crc64_table[(byte)value^*data++]; 
	return value; 
}

//    
qword _crc64(byte *data,int count,qword polynom=POLYNOM64_ECMA2) 
{
	int n;
	qword sum=(qword)-1;
	while(count--) {
		sum^=*data++;
		for(n=0;n<8;n++) sum=(-(sum&1)&polynom)^(sum>>1);
	}
	return sum;
}



void main()
{
	byte data[]="3,1415926535897932384626433832795";
	if(sizeof(qword)!=8 || sizeof(byte)!=1) printf("type error\n\a"),getchar();
	CRC64 crc; qword res1,res2;
	res1=crc.Calc(data,strlen((char*)data));
	res2=_crc64(data,strlen((char*)data));
	if(res1!=0x8e5cde9f15521a0a || res2!=0x8e5cde9f15521a0a) printf("Internal error\n\a"),getchar();
	printf("node\n");
}